/*
 * This file is generated by jOOQ.
*/
package com.tabajara.base.tables.daos;


import com.tabajara.base.tables.Sensor;
import com.tabajara.base.tables.records.SensorRecord;

import io.github.jklingsporn.vertx.jooq.shared.internal.AbstractVertxDAO;

import java.util.List;

import javax.annotation.Generated;

import org.jooq.Configuration;


import io.vertx.core.Future;
import io.github.jklingsporn.vertx.jooq.classic.jdbc.JDBCClassicQueryExecutor;
/**
 * This class is generated by jOOQ.
 */
@Generated(
    value = {
        "http://www.jooq.org",
        "jOOQ version:3.10.5"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class SensorDao extends AbstractVertxDAO<SensorRecord, com.tabajara.base.tables.pojos.Sensor, Integer, Future<List<com.tabajara.base.tables.pojos.Sensor>>, Future<com.tabajara.base.tables.pojos.Sensor>, Future<Integer>, Future<Integer>> implements io.github.jklingsporn.vertx.jooq.classic.VertxDAO<SensorRecord,com.tabajara.base.tables.pojos.Sensor,Integer> {

    /**
     * @param configuration The Configuration used for rendering and query execution.
     * @param vertx the vertx instance
     */
    public SensorDao(Configuration configuration, io.vertx.core.Vertx vertx) {
        super(Sensor.SENSOR, com.tabajara.base.tables.pojos.Sensor.class, new JDBCClassicQueryExecutor<SensorRecord,com.tabajara.base.tables.pojos.Sensor,Integer>(com.tabajara.base.tables.pojos.Sensor.class,configuration,vertx), configuration);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    protected Integer getId(com.tabajara.base.tables.pojos.Sensor object) {
        return object.getSenid();
    }

    /**
     * Find records that have <code>sendescricao IN (values)</code> asynchronously
     */
    public Future<List<com.tabajara.base.tables.pojos.Sensor>> findManyBySendescricao(List<String> values) {
        return findManyByCondition(Sensor.SENSOR.SENDESCRICAO.in(values));
    }

    /**
     * Find records that have <code>senparametro IN (values)</code> asynchronously
     */
    public Future<List<com.tabajara.base.tables.pojos.Sensor>> findManyBySenparametro(List<String> values) {
        return findManyByCondition(Sensor.SENSOR.SENPARAMETRO.in(values));
    }

    /**
     * Find records that have <code>senatualizacao IN (values)</code> asynchronously
     */
    public Future<List<com.tabajara.base.tables.pojos.Sensor>> findManyBySenatualizacao(List<Integer> values) {
        return findManyByCondition(Sensor.SENSOR.SENATUALIZACAO.in(values));
    }

    /**
     * Find records that have <code>senativo IN (values)</code> asynchronously
     */
    public Future<List<com.tabajara.base.tables.pojos.Sensor>> findManyBySenativo(List<String> values) {
        return findManyByCondition(Sensor.SENSOR.SENATIVO.in(values));
    }

    /**
     * Find records that have <code>senvirtual IN (values)</code> asynchronously
     */
    public Future<List<com.tabajara.base.tables.pojos.Sensor>> findManyBySenvirtual(List<String> values) {
        return findManyByCondition(Sensor.SENSOR.SENVIRTUAL.in(values));
    }

    /**
     * Find records that have <code>fktipsenid IN (values)</code> asynchronously
     */
    public Future<List<com.tabajara.base.tables.pojos.Sensor>> findManyByFktipsenid(List<Integer> values) {
        return findManyByCondition(Sensor.SENSOR.FKTIPSENID.in(values));
    }
}
